#!/bin/bash
URL=http://SERVER/PATH/
APTPROXY=SERVER
mkdir /home/user/install
echo "install.sh Skript wird ausgeführt" 

#####################
# neuen Schueler-Account anlegen
#####################
echo "Neuen Benutzer hinzufügen"
adduser schueler --gecos schueler --disabled-password
echo "schueler:secretPassword" | chpasswd

# wer das Passwort im Skript nur verschlüsselt haben will, kann auch folgendes verwenden
# HASH=$(perl -e "print crypt(${PLAINTEXT},${09})")
# usermod -p ${HASH} john

#####################
# Anlegen von overlayfs
#####################
echo "Anlegen von overlayfs"
#install kopiert das schueler Verzeichnis und setzt die zugehörigen Benutzerrechte
install -d -o schueler -g schueler /home/.schueler_rw
mkdir /home/work -p
#sollte der Eintrag in der /etc/fstab schon existieren, machen wir das nicht mehr
echo "none /home/schueler overlay lowerdir=/home/schueler,upperdir=/home/.schueler_rw,workdir=/home/work 0 0" >>/etc/fstab

#####################
# sshd - allow only user user
#####################
echo  "Ändern von sshd_config" 
echo "AllowUsers user" >>sshd_config

#####################
# usr_local_bin scripts
#####################
cd /
wget $URL"usr_bin.tar" -O /usr/local/bin/usr_bin.tar
tar -xvf /usr/local/bin/usr_bin.tar -C /
wget $URL"cleanup-schueler.sh" -O /usr/local/bin/cleanup-schueler.sh
chmod 755 /usr/local/bin/cleanup-schueler.sh
wget $URL"fixMount.sh" -O /usr/local/bin/fixMount.sh
chmod 755 /usr/local/bin/fixMount.sh
wget $URL"monitor.sh" -O /usr/local/bin/monitor.sh
wget $URL"setHostname.sh" -O /usr/local/bin/setHostname.sh
chmod 755 /usr/local/bin/setHostname.sh


#####################
# sudoers ändern - derzeit keine Änderungen notwendig
#####################
#echo "Ändere sudoers"
#wget $URL"sudoers" -O /etc/sudoers


#####################
# Heimverzeichnis nach einem reboot wiederherstellen
#####################
wget $URL"cleanup-schueler.sh" -O /usr/local/bin/cleanup-schueler.sh 
wget $URL"shutdownhook.service" -O /etc/systemd/system/shutdownhook.service 
ln -s /etc/systemd/system/shutdownhook.service /etc/systemd/system/multi-user.target.wants/shutdownhook.service 

#Computer werden per cronjob heruntergefahren, falls Schüler/Lehrer vergessen ihn auszuschalten
#Falls aber doch noch gearbeitet wird, wird man vor dem Herunterfahren noch gefragt, ob man das auch wirklich will
wget $URL"shutdownquestion.sh" -O /usr/local/bin/shutdownquestion.sh
chmod 7555 /usr/local/bin/shutdownquestion.sh

cd /
wget $URL"firefox.tar" -O firefox.tar
wget $URL"chromium.tar" -O chromium.tar
wget $URL"vlc.tar" -O vlc.tar
tar -xvf schueler_klasse.tar
tar -xvf firefox.tar

#####################
# Hostnamen ändern
#####################
echo "Hostnamen ändern"
mac=`( ip address |grep ether |cut -c 16-32)`
wget http://MYSERVER/PATH/getHostname.php?macAddress=$mac -O /etc/hostname

#####################
# Login screen clonen
#####################
#Ist ein Beamer angeschlossen, kann es sein, dass der Login Screen nicht am Monitor erscheint
#monitor.xml klont die Bildschirme, damit ist garantiert, dass der Login Screen auf beiden Ausgabegeräten sichtbar ist.
wget $URL"monitors.xml" -O /var/lib/gdm3/.config/

#####################
# fix apparmor problem
#####################
ln -s /etc/apparmor.d/usr.bin.evince /etc/apparmor.d/disable

ln -s /etc/apparmor.d/usr.lib.libreoffice.program.soffice.bin  /etc/apparmor.d/disable
ln -s /etc/apparmor.d/usr.lib.libreoffice.program.oosplash  /etc/apparmor.d/disable
ln -s /etc/apparmor.d/usr.lib.libreoffice.program.senddoc  /etc/apparmor.d/disable
ln -s /etc/apparmor.d/usr.lib.libreoffice.program.xpdfimport  /etc/apparmor.d/disable


#####################
# crontab installieren
#####################
echo "Crontab anpassen"
wget $URL"crontab.txt" -O crontab.txt
crontab crontab.txt


#####################
# Entfernen von diversen Autostarteinträgen
#####################

#rm /etc/xdg/autostart/gnome-welcome-tour.desktop
#rm /etc/xdg/autostart/org.gnome.DejaDup.Monitor.desktop
#rm /etc/xdg/autostart/spice-vdagent.desktop
#rm /etc/xdg/autostart/org.gnome.SettingsDaemon.Sharing.desktop
#rm /etc/xdg/autostart/update-notifier.desktop
#rm /etc/xdg/autostart/org.gnome.SettingsDaemon.Wacom.desktop
#rm /etc/xdg/autostart/org.gnome.SettingsDaemon.Smartcard.desktop
#rm /etc/xdg/autostart/org.gnome.SettingsDaemon.ScreensaverProxy.desktop
#rm /etc/xdg/autostart/gnome-keyring-pkcs11.desktop
#rm /etc/xdg/autostart/gnome-keyring-secrets.desktop

#####################
# Rsync
#####################
echo "Rsync aufsetzen"
wget $URL"syncdata.sh" -O /usr/local/bin/syncdata.sh
chmod 755 /usr/local/bin/syncdata.sh
mkdir -p /data/local
chown schueler /data/local
chgrp schueler /data/local
echo "mySecretPassword" >/etc/rsyncsecret
chmod 600 /etc/rsyncsecret

#####################
# fix slow shutdown
#####################
systemctl disable cups-browsed.service

#####################
# make vlc default app remove keyring storage
#####################
sed -i 's/rhythmbox/vlc/g' /usr/share/applications/defaults.list
sed -i 's/org.gnome.Totem/vlc/g' /usr/share/applications/defaults.list

#sed -i 's#Exec=/usr/bin/google-chrome-stable#Exec=/usr/bin/google-chrome-stable --password-store=basic#g' /usr/share/applications/google-chrome.desktop
sed -i 's#Exec=chromium-browser#Exec=chromium-browser --password-store=basic#g' /usr/share/applications/chromium-browser.desktop

#####################
# settings
#####################
#wget $URL/settings.sh -O /usr/local/bin/settings.sh
#chmod 755 /usr/local/bin/settings.sh

#
sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.wm.preferences button-layout 'close,maximize,minimize:' 

sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.wm.keybindings switch-windows "['<Alt>Tab']"
sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.wm.keybindings switch-windows-backward "['<Shift><Alt>Tab']"
sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.wm.keybindings switch-applications "[]"
sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.wm.keybindings switch-applications-backward "[]"

sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.interface clock-show-date true
#launcher Icons neu konfigurieren
sudo -Hu schueler dbus-launch gsettings set org.gnome.shell favorite-apps "['org.gnome.Nautilus.desktop','chromium-browser.desktop','firefox.desktop','libreoffice-writer.desktop','libreoffice-calc.desktop','vlc.desktop','geogebra.desktop']"
#Willkommensprogramm deaktivieren
echo "yes" >> /home/schueler/.config/gnome-initial-setup-done


# Bildschirm abschalten nie
sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.session idle-delay 0
# automatische Bildschirmsperre deaktivieren
sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.screensave lock-enabled false
# Blank Screen Delay
sudo -Hu schueler dbus-launch gsettings set org.gnome.desktop.session idle-delay 0

#shut down computer if 12 minutes of inactivity
sudo -Hu schueler dbus-launch org.gnome.settings-daemon.plugins.power.sleep-inactive-ac-timeout 720
sudo -Hu schueler dbus-launch org.gnome.settings-daemon.plugins.power.sleep-inactive-ac-type 'shutdown'

#####################
# apt Sourcen anpassen und apt proxy setzen
#####################
echo "Sourcen anpassen" 
# wir laden die Sourcen vom Server bzw. erstellen wir zusätzliche
wget $URL"sources.list" -O /etc/apt/sources.list 
wget $URL"ppasources.list" -O /etc/apt/sources.list.d/ppasources.list 
echo "deb http://www.geogebra.net/linux/ stable main " >/etc/apt/sources.list.d/geogebra.list

#echo "Acquire::http::Proxy \"http://"APTPROXY":3142/apt-cacher/\";" >/etc/apt/apt.conf
#für https Quellen funktioniert der Proxy nicht
echo "Acquire::https::Proxy \"false\";" >>/etc/apt/apt.conf

#geogebra
wget -q -O - http://www.geogebra.net/linux/office@geogebra.org.gpg.key | apt-key add -

#####################
# Zusätzliche Software installieren
#####################
echo "Installiere zusätzliche Pakete"
cd /home/user/install

# codium https://vscodium.com/ - visual studio code ohne tracking/telemetry
wget -qO - https://gitlab.com/paulcarroty/vscodium-deb-rpm-repo/raw/master/pub.gpg | apt-key add -
echo 'deb https://gitlab.com/paulcarroty/vscodium-deb-rpm-repo/raw/repos/debs/ vscodium main' | sudo tee --append /etc/apt/sources.list.d/vscodium.list
apt update && sudo apt install codium


wget https://dl.google.com/linux/direct/google-webdesigner_current_amd64.deb O /home/user/install/webdesigner.deb
dpkg -i /home/user/install/webdesigner.deb


#####################
# Alle Pakete installieren
#####################
cd /home/user/install
# Die Paketliste vom Server herunterladen
wget $URL"packages.txt"
apt-get update
apt-get install -y openssh-server

# Akzeptieren der EULA über debconf. Es wird sonst nachgefragt, und nachdem die Installation nicht interaktiv ist, würde er hier stehenbleiben
echo 'ttf-mscorefonts-installer msttcorefonts/accepted-mscorefonts-eula boolean true' | debconf-set-selections
echo "Pakete installieren"
echo 'libc6             libraries/restart-without-asking boolean true'| debconf-set-selections
echo 'libc6:amd64       libraries/restart-without-asking boolean true'| debconf-set-selections
echo 'libpam0g:amd64    libraries/restart-without-asking boolean true'| debconf-set-selections
echo 'libssl1.1         libraries/restart-without-asking boolean true'| debconf-set-selections
echo 'libssl1.1         libraries/restart-without-asking boolean true'| debconf-set-selections

#systemctl stop snapd.service
if apt-get install -y `cat packages.txt` ;
then
   echo "Alle Pakete wurden erfolgreich installiert"
else
   echo "ERROR - Es konnten nicht alle Pakete installiert werden."
   # Wir starten noch einen Versuch
   apt-get install -y -f
   apt-get install -y  `cat packages.txt`
fi

apt-get upgrade -y

#####################
# Pakete entfernen
#####################
wget $URL"remove.txt"
if apt-get remove -y --purge `cat remove.txt` ; then
   echo "Alle Pakete wurden erfolgreich entfernt."
else
   echo "ERROR - Es konnten nicht alle Pakete entfernt werden."
fi
echo "Autoremove Pakete"
apt-get autoremove -y

